﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Controls;

using Microsoft.Reporting.WinForms;
using System.Drawing.Imaging;
using System.Drawing.Printing;
using System.IO;
using Syncfusion.ReportWriter;
using Syncfusion.Windows.PdfViewer;

namespace test_ReportDesigner002
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {       
            //Send list data in form1 (from gridGroupingControl1 )to form10 and reportViewerContainer in form10 data sources from  gridGroupingControl1
            // reportDesignerContainer - edit reportViewerControl.ReportPath = @"../../Report1.rdlc";

            Form10 settingsForm = new Form10(this.productBindingSource3);
            settingsForm.Location = new Point(100, 100);
            settingsForm.ShowDialog();
        }


        private void button2_Click(object sender, EventArgs e)
        {
            //Send list data in form1 (from gridGroupingControl1 )to form2 and reportViewerControl.DataSources.Add list from gridGroupingControl1
   
            //var Result = productDataGridView.Rows.OfType<DataGridViewRow>().Select(
            //r => r.Cells.OfType<DataGridViewCell>().ToDictionary(c => productDataGridView.Columns[c.ColumnIndex].HeaderText, c => (c.Value ?? "").ToString()
            //    ).ToList());

        //   gridGroupingControl1



            Form2 settingsForm = new Form2(this.productBindingSource3);
            settingsForm.Location = new Point(100, 100);
            settingsForm.ShowDialog();
        }

        private void productBindingNavigatorSaveItem_Click(object sender, EventArgs e)
        {
            this.Validate();
            this.productBindingSource.EndEdit();
            this.tableAdapterManager.UpdateAll(this.test009DataSet);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'test009DataSet.Product' table. You can move, or remove it, as needed.
            this.productTableAdapter.Fill(this.test009DataSet.Product);
            // TODO: This line of code loads data into the 'test009DataSet1.Product' table. You can move, or remove it, as needed.
            this.productTableAdapter.Fill(this.test009DataSet1.Product);
            // TODO: This line of code loads data into the 'test009DataSet1.Product' table. You can move, or remove it, as needed.
            this.productTableAdapter.Fill(this.test009DataSet1.Product);
            // TODO: This line of code loads data into the 'test009DataSet.Product' table. You can move, or remove it, as needed.
            this.productTableAdapter.Fill(this.test009DataSet.Product);

            this.reportViewer1.RefreshReport();
        }

        private void productDataGridView_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void button3_Click(object sender, EventArgs e)
        {
            //directly print Report1.rdlc to printer with vieweing in report viewer.

            ReportWriter reportWriter = new ReportWriter();
            try
            {
                string reportPath = @"../../Report1.rdlc";
                reportWriter.ReportPath = reportPath;
                reportWriter.ReportProcessingMode = Syncfusion.ReportWriter.ProcessingMode.Local;
                reportWriter.DataSources.Clear();
                reportWriter.DataSources.Add(new Syncfusion.Windows.Reports.ReportDataSource { Name = "DataSet1", Value = this.productBindingSource3 });

                MemoryStream stream = new MemoryStream();
                reportWriter.Save(stream, WriterFormat.PDF);
                PdfDocumentView pdfViewer = new PdfDocumentView();
                pdfViewer.Load(stream);
                System.Windows.Controls.PrintDialog printDialog = new System.Windows.Controls.PrintDialog();

                if ((bool)printDialog.ShowDialog())
                {
                    printDialog.PrintDocument(pdfViewer.PrintDocument.DocumentPaginator, "PDF PRINTER");
                }
            }
            catch (Exception Ex)
            {
                MessageBox.Show(Ex.Message);
            }

            //    https://www.syncfusion.com/kb/4803/how-to-print-the-rdlc-report-directly-without-viewing

            //Stream reportStream = assembly.GetManifestResourceStream("DirectPrinting.Grouping Report1.rdlc");
            //ReportWriter writer = new ReportWriter();
            //writer.ReportProcessingMode = Syncfusion.ReportWriter.ProcessingMode.Local;
            //writer.DataSources.Clear();
            //writer.DataSources.Add(new ReportDataSource { Name = "Customers", Value = Customers.GetData() });
            //writer.LoadReport(reportStream);
            //MemoryStream stream = new MemoryStream();
            //writer.Save(stream, WriterFormat.PDF);

            //PdfDocument pdfDoc = await PdfDocument.LoadFromStreamAsync(randomStream);
            //printPreviewPages.Clear();
            //for (uint i = 0; i < pdfDoc.PageCount; i++)
            //{
            //    var bitmap = new BitmapImage();
            //    MemoryStream mStream = new MemoryStream();
            //    var outStream = mStream.AsRandomAccessStream();
            //    await pdfDoc.GetPage(i).RenderToStreamAsync(outStream, new PdfPageRenderOptions());
            //    bitmap.SetSource(outStream);
            //    Image image = new Image();
            //    image.Stretch = Stretch.Fill;
            //    image.Source = bitmap;
            //    printPage = new Page();
            //    printPage.Content = image;
            //    printPreviewPages.Add(printPage);
            //}

            //// Loop over all the preview pages and add  each page to be printed.
            //for (int i = 0; i < printPreviewPages.Count; i++)
            //{
            //    //All pages should be ready at this point...
            //    printDocument.AddPage(printPreviewPages[i]);
            //}
            //PrintDocument printDoc = (PrintDocument)sender;
            //// Indicates that all the pages to be printed are provided.
            //printDoc.AddPagesComplete();

            //https://www.syncfusion.com/kb/6431/how-to-export-a-report-without-viewing-in-reportviewer

            //Stream rdlStream = this.GetType().Assembly.GetManifestResourceStream("LightSwitchApplication.ReportTemplate.GroupingAggReport.rdlc");
            //ReportWriter writer = new ReportWriter();
            //writer.ReportProcessingMode = ProcessingMode.Local;
            //writer.LoadReport(rdlStream);
            //writer.DataSources.Add(new ReportDataSource { Name = "Sales", Value = items });
            //writer.ExportCompleted += writer_ExportCompleted;
            //writer.Save(System.IO.Path.GetTempPath() + "Exported_Report.pdf", WriterFormat.PDF);
        }
    }
}
